# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (c) 2013 E-MIPS (http://www.e-mips.com.ar) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp import _, api, fields, models


class account_invoice(models.Model):
    _inherit = "account.invoice"

    clearance_id = fields.Many2one('import.clearance','Related Clearance')
    clearance_taxable = fields.Boolean('Clearance Taxable', help="Check this if it will be used for base taxable base.", default=False)
    advancement_type_id = fields.Many2one('import.advancement.type', 'Advancement Type', required=False, help="Default advancement type used to pay.")

    @api.multi
    def action_move_create(self):
        """Funcion heredada para asociar el movimiento de la factura
           al despacho de importacion."""
        clearance_model = self.env['import.clearance']

        res = super(account_invoice, self).action_move_create()

        # Obtenemos el move, si es un clearance
        for invoice in self:
            clearances = clearance_model.search([('invoice_ids', 'in', [invoice.id])])
            if clearances:
                clearances.write({'account_move_ids': [(4, invoice.move_id.id, _)]})

        return res

    # HACK: No se pudo hacer desde la vista.
    @api.model
    def create(self, vals):
        if 'clearance_id' in vals and vals['clearance_id']:
            vals['type'] = 'in_invoice'

        return super(account_invoice, self).create(vals)


class account_invoice_line(models.Model):
    _inherit = "account.invoice.line"

    clearance_id = fields.Many2one('import.clearance', 'Clearance')
