# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2011
#
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from openerp import models, fields, api, exceptions, _


class retention_tax_line(models.Model):
    _name = "retention.tax.line"
    _inherit = "retention.tax.line"

    clearance_id = fields.Many2one('import.clearance', 'Clearance')

    def create_move_line(self, cr, uid, retention, reference, date, journal_id, partner_id, context=None):
        period_obj = self.pool.get('account.period')

        move_lines = []

        if retention.amount == 0.0:
            return move_lines

        # Chequeamos si esta seteada la fecha, sino le ponemos la fecha del voucher
        retention_vals = {}
        if not retention.date:
            retention_vals['date'] = date

        period_ids = period_obj.find(cr, uid, date, context=context)
        period_id = period_ids and period_ids[0] or False

        #company_currency = voucher.company_id.currency_id.id
        #current_currency = voucher.currency_id.id

        #tax_amount_in_company_currency =  voucher_obj._convert_paid_amount_in_company_currency(cr, uid, voucher, retention.amount, context=context)
        #base_amount_in_company_currency =  voucher_obj._convert_paid_amount_in_company_currency(cr, uid, voucher, retention.base, context=context)

        debit = credit = 0.0

        # Lo escribimos en el objeto retention_tax_line
        tax_amount = retention.amount #tax_amount_in_company_currency
        base_amount = retention.base #base_amount_in_company_currency

        #credit = tax_amount
        #if debit < 0: credit = -debit; debit = 0.0
        #if credit < 0: debit = -credit; credit = 0.0
        #sign = debit - credit < 0 and -1 or 1

        # Creamos la linea contable perteneciente a la retencion
        move_line = {
            'type': 'tax',
            'name': retention.name,
            'ref': reference,
            'partner_id': partner_id,
            'price_unit': tax_amount,
            'quantity': 1,
            'price': tax_amount or 0.0,
            'account_id': retention.account_id.id,
            'tax_code_id': retention.tax_code_id.id,
            'tax_amount': tax_amount,
        }

        move_lines.append(move_line)

        # ...y ahora creamos la linea contable perteneciente a la base imponible de la retencion
        # Notar que credit & debit son 0.0 ambas. Lo que cuenta es el tax_code_id y el tax_amount
        move_line = {
            'type': 'tax',
            'name': retention.name + '(Base Imp)',
            'ref': reference,
            'partner_id': partner_id,
            'price_unit': 0.0,
            'quantity': 1,
            'price': 0.0,
            'account_id': retention.account_id.id,
            'tax_code_id': retention.base_code_id.id,
            'tax_amount': base_amount,
        }

        move_lines.append(move_line)
        return move_lines

retention_tax_line()
