# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (c) 2014 E-MIPS (http://www.e-mips.com.ar)
#    Copyright (c) 2014 Eynes (http://www.eynes.com.ar)
#    All Rights Reserved. See AUTHORS for details.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp import api, fields, models


class add_expense_invoice(models.TransientModel):
    _name = "add.expense.invoice"
    _description = "Add Expense Invoice"

    invoice_id = fields.Many2one('account.invoice', 'Invoice', required=True)
    invoice_line_ids = fields.Many2many('account.invoice.line', 'add_exp_inv_line_rel',
                                        'add_exp_id', 'inv_line_id', 'Invoice Lines')

    @api.model
    def _prepare_inv_line(self, account_id, line):
        """Collects require data from purchase order line that is used to create invoice line
        for that purchase order line
        :param account_id: Expense account of the product of PO line if any.
        :param browse_record line: Purchase order line browse record
        :return: Value for fields of invoice lines.
        :rtype: dict
        """
        return {
            'name': line.name,
            'account_id': account_id,
            'price_unit': line.price_unit or 0.0,
            'quantity': line.quantity or 1,
            'product_id': line.product_id.id,
            'uos_id': line.product_id.uom_id.id or False,
            #'invoice_line_tax_id': [(6, 0, [x.id for x in line.taxes_id])],
            #'account_analytic_id': line.account_analytic_id.id or False,
        }

    @api.multi
    def use_invoice_lines(self):
        # Clearance
        clearance_id = self.env.context['active_ids'][0]
        return self.invoice_line_ids.write({'clearance_id': clearance_id})
